/*

[----------------------------------------]
##########################################
#  ### # ## ###     ##  ###  #    ########
# # ## # # #### ### ## # # # # ### #######
# ## # #  #####     ## ## ## #    ########
# ## # # # #### ### ## ## ## # ###########
# ##  ## ## ### ### ## ##### # ###########
##########################################
[---------Version 1.0 for Allegro--------]

NKAMP and it's code, my hard work, etc. is (C) 1999 Nick Kochakian

Web:    http://come.to/dn3
E-mail: nickk@worldnet.att.net
*/

#include "nkamp.h"
#include <stdio.h>
#include <stdlib.h>

typedef struct RADHeader {
        unsigned char ID_string[16];
        unsigned char rad_version; //Currently 10h (1.0)
        unsigned char rad_flag;
} RADHeader;

NKAMP *load_rad(char *filename) {

RADHeader rad;
NKAMP     *r;

FILE *f;
unsigned char byte;
int i;
int channel, line, pattern;
unsigned char num_instruments;
unsigned char line_temp, cur_line;
unsigned char ch_temp, ch, flag, flag2;
int last_pos, file_begin;

unsigned short pat_offs[32]; //The offset to the pattern
                             //If offset = 0 the the pattern is
                             //empty.

r=(NKAMP *)malloc(sizeof(NKAMP));
if (!r)
   return NULL;

r->Pat=(NKAMPPattern *)malloc(32 * sizeof(NKAMPPattern));
if (!r->Pat)
   return NULL;

f=fopen(filename,"rb");
if (f==NULL)
   return NULL;

file_begin=ftell(f);

fread(&rad, 1, sizeof(RADHeader), f);

//Verify that this IS a RAD module:
if (rad.ID_string[0] != 'R' || rad.ID_string[1] != 'A' || rad.ID_string[2] != 'D')
   return NULL;

r->initial_speed=(rad.rad_flag & 0x1F);
r->cur_line=r->cur_pattern=r->cur_order=0;
r->cur_speed=r->initial_speed;

if ((rad.rad_flag & 0x40)) //Bit 6 is set if the tune is in "slow mode"
   r->slow_timer=1;
   else
   r->slow_timer=0;

if ((rad.rad_flag & 0x80)) { //Skip the description
   for (;;) {
       fread(&byte, 1, 1, f);
       if (byte==0) //End of description
          break;
   }
}

//Load the instruments:
last_pos=ftell(f);
num_instruments=0;
for (;;) {
    fread(&byte, 1, 1, f);
    if (byte==0)
       break;

    fseek(f, 11, SEEK_CUR);
    num_instruments++;
}

if (num_instruments==0)
   return NULL;

fseek(f, last_pos, SEEK_SET);
r->num_inst=num_instruments;
r->Inst=(NKAMPInst *)malloc(num_instruments * sizeof(NKAMPInst));
if (!r->Inst)
   return NULL;

i=0;
for (;;) {
    fread(&byte, 1, 1, f);
    if (byte==0)
       break;

    fread(&r->Inst[i], 1, sizeof(NKAMPInst), f);
    i++;
}

fread(&r->num_orders, 1, 1, f);

r->Order=(NKAMPOrder *)malloc(r->num_orders * sizeof(NKAMPOrder));
if (!r->Order)
   return NULL;

for (i=0; i<r->num_orders; i++)
    fread(&r->Order[i], 1, sizeof(NKAMPOrder), f);

for (i=0; i<32; i++)
    fread(&pat_offs[i], 1, 2, f);

//Reset all of the patterns:
for (pattern=0; pattern<32; pattern++) {
    for (channel=0; channel<9; channel++) {
        for (line=0; line<64; line++) {
            r->Pat[pattern].channel[channel].line[line].is_used=0;
        }
    }
}

//Load all of the filled patterns, and skip the empty ones:
for (pattern=0; pattern<32; pattern++) {
    if (pat_offs[pattern]>0) { //This pattern is filled, let's load it!
       fseek(f, file_begin, SEEK_SET);
       fseek(f, pat_offs[pattern], SEEK_CUR);

       for (;;) { //This loads all of the lines
           fread(&line_temp, 1, 1, f); //Get the line number that's to
                                      //be loaded.

           cur_line=(line_temp & 0x7F); //Take off bit 7

           for (;;) { //Loads all of the channel data for this line
               fread(&ch_temp, 1, 1, f); //Which channel does the note go into? :)
               ch=(ch_temp & 0x7F); //Take off bit 7

               //I have to try not to forget to set this! :)
               r->Pat[pattern].channel[ch].line[cur_line].is_used=1;

               //Now, lets grab that note: (2 bytes)
               fread(&r->Pat[pattern].channel[ch].line[cur_line].note[0], 1, 1, f);
               fread(&r->Pat[pattern].channel[ch].line[cur_line].note[1], 1, 1, f);

               flag=r->Pat[pattern].channel[ch].line[cur_line].note[1];
               //If bit 3 is set of the second byte of the note (which is a
               //nibble... Bits 0-3 = 4 bits, ok? ;), then the effect value
               //has to be loaded!
               if ((flag & 0xF) != 0)
                  fread(&r->Pat[pattern].channel[ch].line[cur_line].effect, 1, 1, f);
                  else
                  r->Pat[pattern].channel[ch].line[cur_line].effect=0;

               if ((ch_temp & 0x80)) //That's it for this line
                  break;
           }

           if ((line_temp & 0x80)) //That's it for this pattern
              break;
       }
    }
}

fclose(f);

return r;
}
